class Ball extends PhysicsObject {
  
  private float size = 10;
  private int start = 120;
  private PhysicsObject lastTouch;
  
  Ball () {
    super(10,10, 5, 0,0, 1,1);
  }
  Ball (float newSize, float newSpeed, float newPosX, float newPosY, float newDirX, float newDirY) {
    super(newSize, newSize, newSpeed, newPosX, newPosY, newDirX, newDirY);
    size = newSize;
  }
  Ball (float newSize) {
    super(newSize,newSize, 5, 0,0, 1,1);
    size = newSize;
  }
  
  protected void step () {
    if (start > 0) {
      this.setPos(PVector.add(this.getPos(), PVector.mult(this.getDir(), (120.0-(float)start)/120.0 * this.getSpeed())));
      start -= 1;
    } else{  
      this.setPos(PVector.add(this.getPos(), PVector.mult(this.getDir(), this.getSpeed())));
    }
  }
  
  protected void display () {
    ellipse(this.getPos().x, this.getPos().y, 20, 20);
  }
  
  protected PhysicsObject getLastTouch () {
    return lastTouch;
  }
  protected void setLastTouch (PhysicsObject tObj) {
    lastTouch = tObj;
  }
  protected void resetLastTouch () {
    lastTouch = null;
  }
  
  protected void reset() {
    start = 120;
    this.setPos(width/2, height/2);
    this.setDir(random(-1,1), random(-1,1));
  }
}
