class PhysicsObject {
  
  private float speed = 0;
  private PVector dim = new PVector(0,0);
  private PVector dir = new PVector(0,0);
  private PVector pos = new PVector(0,0);
  
  PhysicsObject () {
  }
  
  PhysicsObject(float newDimX, float newDimY, float newSpeed, float newPosX, float newPosY, float newDirX, float newDirY) {
    speed = newSpeed;
    dim = new PVector(newDimX, newDimY);
    pos = new PVector(newPosX, newPosY);
    this.setDir(newDirX, newDirY);
  }
  
  protected void display () {
    //
  }
  
  protected void step () {
    pos = PVector.add(pos, PVector.mult(dir, speed));
  }
  
  protected void invertDir (String cmd) {
    if (cmd == "x") {
      dir.x = -dir.x;
    } else if (cmd == "y") {
      dir.y = -dir.y;
    } else if (cmd == "xy") {
       dir.x = -dir.x;
       dir.y = -dir.y;
    }
  }
  
  protected PVector getDim () {
    return dim;
  }
  protected float getSpeed () {
    return speed;
  }
  protected PVector getPos () {
    return pos;
  }
  protected PVector getDir () {
    return dir;
  }
  
  protected void setDim (float newDimX, float newDimY) {
    dim = new PVector(newDimX, newDimY);
  }
  protected void setDimX (float newDimX) {
    dim.x = newDimX;
  }
  protected void setDimY (float newDimY) {
    dim.y = newDimY;
  }
  
  protected void setSpeed (float newSpeed) {
    speed = abs(newSpeed);
  }
  protected void setPos (float newPosX, float newPosY) {
    pos = new PVector(newPosX, newPosY);
  }
  protected void setPos (PVector newPos) {
    pos = newPos;
  }
  protected void setX (float newPosX) {
    pos.x = newPosX;
  }
  protected void setY (float newPosY) {
    pos.y = newPosY;
  }
  protected void setDir (float newDirX, float newDirY) {
    PVector newDir = new PVector(newDirX, newDirY);
    newDir.normalize();
    dir = newDir;
  }
}
