import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;
import java.util.*;
import oscP5.*;
import netP5.*;

OscP5 oscP5_3330;
OscP5 oscP5_3331;
OscP5 oscP5_3332;
OscP5 oscP5_3333;

Minim minim;

GUI gui;
Physics g;
State state;

void setup () {
  
  // to enable different tuio streams
  // simply uncomment the ones you want: top, right, bottom, left
  // remember to then disable the respective AI in the controlConfig tab
  /* 
  oscP5_3330 = new OscP5(this,3330);
  oscP5_3330.plug(this,"tuioCtrlTop","/tuio/2Dcur","sifffff");
  
  oscP5_3331 = new OscP5(this,3331);
  oscP5_3331.plug(this,"tuioCtrlRight","/tuio/2Dcur","sifffff");
  
  oscP5_3332 = new OscP5(this,3332);
  oscP5_3332.plug(this,"tuioCtrlBottom","/tuio/2Dcur","sifffff");
  
  oscP5_3333 = new OscP5(this,3333);
  oscP5_3333.plug(this,"tuioCtrlLeft","/tuio/2Dcur","sifffff");
  */
  
  minim = new Minim(this);
  gui = new GUI(800,800);
  state = new State();
  g = new Physics();
    
    ArrayList<PhysicsObject> pList = new ArrayList<PhysicsObject>();
    
    pList.add(new Plattform(100, 20, 100,10, 10));
    pList.add(new Plattform(width-20,height-100, 10,100, 10));
    pList.add(new Plattform(width-100,height-20, 100,10, 10));
    pList.add(new Plattform(20,100, 10,100, 10));
    
    for (int i = 0; i < 2; i++) {
      pList.add(new Ball(20.0, 6, height/2,width/2, random(-1,1),random(-1,1)));
    }
    
    for (PhysicsObject p : pList) {
      if ( p.getClass() == Plattform.class ) {
        ((Plattform)p).setRange(new PVector(20, width-20), new PVector(20, height-20));
      }
    }
    g.addObjects(pList);
  
    
}

void draw () {
  
  gui.drawState(state.gameMode);
  
  switch(state.gameMode)
  {
  case State.GAME_MODE_MENU:
    drawMenu();
    break;
  case State.GAME_MODE_PLAY:
    drawGame();
    break;  
  case State.GAME_MODE_GAMEOVER:
    drawEnd();
    break;
  }  
 
  if (keyDown(ENTER)) {
    gui.player.pause();
    gui = null;
    state = null;
    g = null;
    setup();
    state.startMenu();
  } 
}

void drawMenu () {
  if (keyDown(' ')) { //space
    state.startGame();
  }
}

void drawGame () {
  controls();
  g.step();
  g.displayObjs();
  state.step();
}

void drawEnd () {
  gui.draw_GAMEOVER();
}


HashSet<Integer> keysDown = new HashSet<Integer>();

void keyPressed() {
  keysDown.add(keyEvent.getKeyCode());
}

void keyReleased() {
  keysDown.remove(keyEvent.getKeyCode());
}

boolean keyDown(int kcode){
  return keysDown.contains(kcode);
}
